#delimit ;
version 6.0;

/*
** syntax: interact var1 var12, cond(var2) val(value)
*/
program define interact;
    syntax varlist, COND(varname numeric) VALue(real);
    tokenize `varlist';
    loc v1 `1';
    loc v12 `2';

    tempname V b m1 m2 m3;

    mat V = e(V);
    mat b = e(b);

    mat m1 = b[1,"`v1'"];
    mat m2 = b[1,"`v12'"];

    loc coeff = m1[1,1] + `value'*m2[1,1];

    mat m1 = V["`v1'","`v1'"];
    mat m2 = V["`v12'","`v12'"];
    mat m3 = V["`v1'","`v12'"];

    loc se = sqrt(m1[1,1] + `value'*`value'*m2[1,1] + 2*`value'*m3[1,1]);
    loc tval = `coeff' / `se';
    loc prob = normprob(-abs(`tval'))*2;
    loc confp = 1 - ((100 - $S_level)/2)/100;
    loc ci = invnorm(`confp');
    loc ub = `coeff' + `ci'*`se';
    loc lb = `coeff' - `ci'*`se';

    di;
    di "Condition: `cond'=`value'";
    di "Model    : $S_E_cmd";
    di;
    loc sksp = 8 - length("$S_E_depv");
    di _dup(78) "-";
    di _skip(`sksp') "$S_E_depv |" _col(17) "Coeff." _col(25) "Std.Err."
       _col(41) "z" _col(47) "P>|z|" _col(59) "[" %2.0f $S_level "% Conf. Interval]";
    di _dup(9) "-" "+" _dup(68) "-";
    loc sksp = 8 - length("`v1'");
    di _skip(`sksp') "`v1' |" _col(13) %9.0g `coeff' _col(24) %9.0g `se'
       _col(38) %6.3f `tval' _col(47) %5.3f `prob' _col(58) %9.0g `lb'
       _col(70) %9.0g `ub';
    di _dup(78) "-";
end;
